/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#include "CustomTrackedObjectComponent.h"

#include "Runtime/Launch/Resources/Version.h"

TArray<UCustomTrackedObjectComponent*> UCustomTrackedObjectComponent::Active = TArray<UCustomTrackedObjectComponent*>();

UCustomTrackedObjectComponent::UCustomTrackedObjectComponent()
{
	
}

void UCustomTrackedObjectComponent::BeginPlay()
{
	Super::BeginPlay();

	Active.Add(this);
}
void UCustomTrackedObjectComponent::EndPlay(const EEndPlayReason::Type endPlayReason)
{
	Super::EndPlay(endPlayReason);

	Active.Remove(this);
}

FVector UCustomTrackedObjectComponent::GetSharedPosition() const
{
	if (Origin)
		return Origin->GetActorTransform().InverseTransformPosition(GetComponentLocation());
	else
		return GetComponentLocation();
}
FQuat UCustomTrackedObjectComponent::GetSharedRotation() const
{
	if (Origin)
#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION >= 18
		return Origin->GetActorTransform().InverseTransformRotation(GetComponentRotation().Quaternion());
#else
		return Origin->GetActorTransform().GetRotation().Inverse() * GetComponentRotation().Quaternion();
#endif
	else
		return GetComponentRotation().Quaternion();
}
